Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Interface Queue<E>

Type Parameters:
  `E` - the type of elements held in this collection

All Superinterfaces:
  Collection<E>, Iterable<E>

All Known Subinterfaces:
  BlockingQueue<E>

All Known Implementing Classes:
  AbstractQueue, ArrayBlockingQueue, ConcurrentLinkedQueue, DelayQueue, LinkedBlockingQueue, LinkedList, PriorityBlockingQueue, PriorityQueue, SynchronousQueue

    public interface Queue<E>

extends Collection<E>

A collection designed for holding elements prior to processing. Besides basic `Collection` operations, queues provide additional insertion, extraction, and inspection operations.

Queues typically, but do not necessarily, order elements in a FIFO (first-in-first-out) manner. Among the exceptions are priority queues, which order elements according to a supplied comparator, or the elements' natural ordering, and LIFO queues (or stacks) which order the elements LIFO (last-in-first-out). Whatever the ordering used, the head of the queue is that element which would be removed by a call to `remove()` or `poll()`. In a FIFO queue, all new elements are inserted at the tail of the queue. Other kinds of queues may use different placement rules. Every `Queue` implementation must specify its ordering properties.

The `offer` method inserts an element if possible, otherwise returning `false`. This differs from the `Collection.add` method, which can fail to add an element only by throwing an unchecked exception. The `offer` method is designed for use when failure is a normal, rather than exceptional occurrence, for example, in fixed-capacity (or "bounded") queues.

The `remove()` and `poll()` methods remove and return the head of the queue. Exactly which element is removed from the queue is a function of the queue's ordering policy, which differs from implementation to implementation. The `remove()` and `poll()` methods differ only in their behavior when the queue is empty: the `remove()` method throws an exception, while the `poll()` method returns `null`.

The `element()` and `peek()` methods return, but do not remove, the head of the queue.

The `Queue` interface does not define the blocking queue methods, which are common in concurrent programming. These methods, which wait for elements to appear or for space to become available, are defined in the `BlockingQueue` interface, which extends this interface.

`Queue` implementations generally do not allow insertion of `null` elements, although some implementations, such as `LinkedList`, do not prohibit insertion of `null`. Even in the implementations that permit it, `null` should not be inserted into a `Queue`, as `null` is also used as a special return value by the `poll` method to indicate that the queue contains no elements.

`Queue` implementations generally do not define element-based versions of methods `equals` and `hashCode` but instead inherit the identity based versions from class `Object`, because element-based equality is not always well-defined for queues with the same elements but different ordering properties.

This interface is a member of the Java Collections Framework.

Since:
  1.5
See Also:
  `Collection`, `LinkedList`, `PriorityQueue`, `LinkedBlockingQueue`, `BlockingQueue`, `ArrayBlockingQueue`, `LinkedBlockingQueue`, `PriorityBlockingQueue`

Method Summary
`E` | `element()` Retrieves, but does not remove, the head of this queue.
`boolean` | `offer(E o)` Inserts the specified element into this queue, if possible.
`E` | `peek()` Retrieves, but does not remove, the head of this queue, returning `null` if this queue is empty.
`E` | `poll()` Retrieves and removes the head of this queue, or `null` if this queue is empty.
`E` | `remove()` Retrieves and removes the head of this queue.

Methods inherited from interface java.util.Collection
`add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

Method Detail

### offer

    boolean offer(E o)

  Inserts the specified element into this queue, if possible. When using queues that may impose insertion restrictions (for example capacity bounds), method `offer` is generally preferable to method `Collection.add(E)`, which can fail to insert an element only by throwing an exception.

  Parameters:
    `o` - the element to insert.
  Returns:
    `true` if it was possible to add the element to this queue, else `false`

### poll

    E poll()

  Retrieves and removes the head of this queue, or `null` if this queue is empty.

  Returns:
    the head of this queue, or `null` if this queue is empty.

### remove

    E remove()

  Retrieves and removes the head of this queue. This method differs from the `poll` method in that it throws an exception if this queue is empty.

  Returns:
    the head of this queue.
  Throws:
    `NoSuchElementException` - if this queue is empty.

### peek

    E peek()

  Retrieves, but does not remove, the head of this queue, returning `null` if this queue is empty.

  Returns:
    the head of this queue, or `null` if this queue is empty.

### element

    E element()

  Retrieves, but does not remove, the head of this queue. This method differs from the `peek` method only in that it throws an exception if this queue is empty.

  Returns:
    the head of this queue.
  Throws:
    `NoSuchElementException` - if this queue is empty.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.